//+------------------------------------------------------------------+
//|                                               beta1goldconsta.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define MAGICMA  20050610
#include <b-Lots.mqh>
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double main_1;
   double main_2;
   double signal_1;
   double signal_2;
   int    res;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Alascan
main_1=iCustom(NULL, 0, "i_Trend", 0, 0); //    1 
main_2=iCustom(NULL, 0, "i_Trend", 0, 1); //    2 
signal_1=iCustom(NULL, 0, "i_Trend", 1, 0); //    1 
signal_2=iCustom(NULL, 0, "i_Trend", 1, 1); //    2 

//---- sell conditions
   if(main_1<signal_1 && !(main_2<signal_2))  
     {
      res=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"",MAGICMA,0,Red);
      Lots=GetSizeLot();
      return;
     }
//---- buy conditions
   if(main_1>signal_1 && !(main_2>signal_2))  
     {
      res=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"",MAGICMA,0,Blue);
       Lots=GetSizeLot();
      return;
     }
//----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double main_1;
   double main_2;
   double signal_1;
   double signal_2;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
main_1=iCustom(NULL, 0, "i_Trend", 0, 0); //    1 
main_2=iCustom(NULL, 0, "i_Trend", 0, 1); //    2 
signal_1=iCustom(NULL, 0, "i_Trend", 1, 0); //    1 
signal_2=iCustom(NULL, 0, "i_Trend", 1, 1); //    2 
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) break;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(main_1<signal_1 && !(main_2<signal_2)) OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(main_1>signal_1 && !(main_2>signal_2)) OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         break;
        }
     }
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//----
  }
//+------------------------------------------------------------------+